﻿// This is the main DLL file.

#include "stdafx.h"

#include "DTrace.h"

typedef void (WINAPI * OutputDebugStringAEntry)(
    LPCSTR lpOutputString
    );

// Original Address
static OutputDebugStringAEntry g_d3d_orgOutputDebugStringA = NULL;
static HMODULE g_mod_d3d9d = NULL;

// RefCount
static volatile LONG g_refCount = 0;

void  WINAPI D3DHookOutputDebugStringA(
    LPCSTR lpOutputString
    )
{
    if( g_d3d_orgOutputDebugStringA != NULL )
    {
        g_d3d_orgOutputDebugStringA( lpOutputString );
    }
    Trace::WriteLine( gcnew String(lpOutputString), L"D3D9");
}


void AddHook()
{
    if( InterlockedIncrement( &g_refCount ) == 1 )
    {
        g_mod_d3d9d = GetModuleHandleA( "d3d9d.dll" );
        if( g_mod_d3d9d != NULL )
        {
            APIHook::Hook(
                g_mod_d3d9d, 
                "Kernel32.dll", 
                "OutputDebugStringA",
                (PROC) D3DHookOutputDebugStringA,
                (PROC*) &g_d3d_orgOutputDebugStringA );
        }
    }
}

void ReleaseHook()
{
    if( InterlockedDecrement( &g_refCount ) == 0 )
    {
        if( g_d3d_orgOutputDebugStringA != NULL )
        {
            APIHook::Hook(
                g_mod_d3d9d, 
                "Kernel32.dll", 
                "OutputDebugStringA",
                (PROC) g_d3d_orgOutputDebugStringA,
                NULL );
            g_d3d_orgOutputDebugStringA = NULL;
            g_mod_d3d9d = NULL;
        }
    }
}