﻿// DTrace.h

#pragma once

using namespace System;
using namespace System::Diagnostics;

void AddHook();
void ReleaseHook();

namespace orzEngine {

    public ref class DTrace : Microsoft::Xna::Framework::GameComponent
	{
    private:
        void OnExit(Object^ sender, Microsoft::Xna::Framework::GameEventArgs^ e)
        {
            ReleaseHook();
            Game->Exiting -= gcnew System::EventHandler<Microsoft::Xna::Framework::GameEventArgs^>(this, &DTrace::OnExit);
            AppDomain::CurrentDomain::get()->DomainUnload -= gcnew System::EventHandler(this, &DTrace::OnDomainUnload );
        }
        void OnDomainUnload(Object^ sender, EventArgs^ e)
        {
            ReleaseHook();
        }
    protected:
        ~DTrace()
        {
        }
    public:
        DTrace()
        {
        }
        virtual void Start() override
        {
            AddHook();
            Game->Exiting += gcnew System::EventHandler<Microsoft::Xna::Framework::GameEventArgs^>(this, &DTrace::OnExit);
            AppDomain::CurrentDomain::get()->DomainUnload += gcnew System::EventHandler(this, &DTrace::OnDomainUnload );
        }
	};
}
